#include "class_dialog_hv.h"

ClassImp(HVManager)

// constructor
HVManager::HVManager(const TGWindow *p, UInt_t w, UInt_t h) : TGMainFrame() {
	// initialization
	//parentApp = p;
	flag_connected = 0;
	flag_auto_update = 1;
	flag_exit = 0;
	InitGUI(p,w,h);
	statusbar->SetText("Ready");
}

// destructor
HVManager::~HVManager() {  }

void HVManager::Exit() {
	gApplication->Terminate();
}

void HVManager::Welcome() {
	cout << endl;
	cout << "=======================================" << endl;
	cout << " (C) davide84                          " << endl;
	cout << "=======================================" << endl;
	cout << endl;
}

void HVManager::Connect() {
	if (flag_connected==0) {
		AddLabels();
		flag_connected=1;
		textbt_connect->SetText("Disconnect");
	} else {
		RemoveLabels();
		flag_connected=0;
	}
}

void HVManager::AddLabels() {
	int row = 0;
	TGLabel *label_values[11];
	label_values[row]	= new TGLabel(tggroup_channels,"Power");
	row++;	label_values[row]	= new TGLabel(tggroup_channels,"Polarity");
	row++;	label_values[row]	= new TGLabel(tggroup_channels,"Temperature");
	row++;	label_values[row]	= new TGLabel(tggroup_channels,"V_MAX");
	row++;	label_values[row]	= new TGLabel(tggroup_channels,"Voltage");
	row++;	label_values[row]	= new TGLabel(tggroup_channels,"Current");
	row++;	label_values[row]	= new TGLabel(tggroup_channels,"PWDown mode");
	row++;		label_values[row]	= new TGLabel(tggroup_channels,"Ramp UP");
	row++;		label_values[row]	= new TGLabel(tggroup_channels,"Ramp DOWN");
	row++;	label_values[row]	= new TGLabel(tggroup_channels,"Trip time");
	row++;		label_values[row]	= new TGLabel(tggroup_channels,"Status");
	for (int i=0; i<=row; i++) {
		tggroup_channels->AddFrame(label_values[i], new TGTableLayoutHints(0, 1, i, i+1, kLHintsExpandY | kLHintsShrinkX | kLHintsShrinkY | kLHintsLeft | kLHintsCenterY | kLHintsFillX | kLHintsFillY, 1, 1, 1, 1));
	}
	tggroup_channels->Resize();
	UpdateGUI();
}

void HVManager::RemoveLabels() {
	TGFrameElement *el;
	TIter next(tggroup_channels->GetList());
	while ((el = (TGFrameElement *) next())) {
		tggroup_channels->HideFrame(el->fFrame);
		tggroup_channels->RemoveFrame(el->fFrame);
		delete el->fFrame;
	}
}

void HVManager::UpdateGUI() {
	mainframe_main->MapSubwindows();
	mainframe_main->Resize();
//	mainframe_main->MapWindow();
	//mainframe_main->Layout();
}

void HVManager::InitGUI(const TGWindow *p, UInt_t w, UInt_t h) {
	// main window ("mainframe")
	mainframe_main = new TGMainFrame(p, w, h);		// Create test main frame. A TGMainFrame is a top level window.
	mainframe_main->SetCleanup(kDeepCleanup);			// use hierarchical cleaning
	mainframe_main->Connect("CloseWindow()", "HVManager", this, "Exit()");
	// main layout
	TGVerticalFrame *vframe_mainlayout = new TGVerticalFrame(mainframe_main, 0, 0, kLHintsExpandX);

	// connection groupbox
	TGGroupFrame *tggroup_connection = new TGGroupFrame(vframe_mainlayout, "Connection", kHorizontalFrame);
	// "Connect" button
	textbt_connect = new TGTextButton(tggroup_connection,"Connect");
	textbt_connect->ChangeOptions(textbt_connect->GetOptions() | kFixedSize); 
	textbt_connect->Resize(90,21);
	textbt_connect->Connect("Clicked()", "HVManager", this, "Connect()");
	// layout
	tggroup_connection->AddFrame(textbt_connect,												new TGLayoutHints(kLHintsLeft, 5, 5, 5, 0));
	vframe_mainlayout->AddFrame(tggroup_connection,	new TGLayoutHints(kLHintsExpandX, 5, 5));

	// channel modules
	tggroup_channels = new TGGroupFrame(vframe_mainlayout, "Channel monitor and settings", kHorizontalFrame);
	tlay_channels = new TGTableLayout(tggroup_channels,12,7);
	tggroup_channels->SetLayoutManager(tlay_channels);
	vframe_mainlayout->AddFrame(tggroup_channels,	new TGLayoutHints(kLHintsExpandX | kLHintsExpandX, 5, 5, 5, 10));

	// canvas window
	mainframe_main->AddFrame(vframe_mainlayout, new TGLayoutHints(kLHintsExpandX | kLHintsExpandY, 2, 2, 2, 2));
	// status bar
	statusbar = new TGStatusBar(mainframe_main, 50, 10, kHorizontalFrame);
	mainframe_main->AddFrame(statusbar, new TGLayoutHints(kLHintsBottom | kLHintsLeft | kLHintsExpandX, 0, 0, 0, 0));
	// showing window
	mainframe_main->SetWindowName("HV Manager");
	UpdateGUI();
	mainframe_main->MapWindow();
	Welcome();

}

